import { createBunServeHandler } from "trpc-bun-adapter";
import { appRouter } from "./router.ts"

Bun.serve(createBunServeHandler({
  router: appRouter,
  responseMeta() {
    return {
      status: 200,
      headers: {
        "Access-Control-Allow-Origin": "*",
        "Access-Control-Allow-Methods": "GET, PUT, POST, OPTIONS",
        "Access-Control-Allow-Headers": "Content-Type, Authorization"
      }
    }
  }
}, {
  port: 3002,
  fetch() {
    return Response.json({ message: "Not Found" }, { status: 404 });
  }
}))
